function getMainWindow() {
	// Return the compose window
	var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIWebNavigation)
                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                   .rootTreeItem
                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIDOMWindow);
	return mainWindow;
}

function filltextarea(fromComposeWindow) {
	var mainWindow = getMainWindow();
	var mailDOM = mainWindow.gMsgCompose.editor.document;
	var mailHtml = mailDOM.getElementsByTagName("HTML")[0].innerHTML;
	mailHtml = mailHtml.replace(/(<\/\w+>)/g, "$1\n");
	mailHtml = mailHtml.replace(/\n+/g, "\n");
	if (fromComposeWindow) {
		var browser = document.getElementById("editHTMLbrowser");
		var doc = browser.contentWindow.document;
		var editarea = doc.getElementById("editarea");
	}
	else
		var editarea = document.getElementById("editarea");
	if (editarea)
		editarea.value = mailHtml;
}
		
function loadarea() {
	var mainWindow = getMainWindow();
	var ed = mainWindow.gMsgCompose.editor;
	ed.QueryInterface(Components.interfaces.nsIHTMLEditor);
	var newDom = document.getElementById("editarea").value;
	// Fix for broken links on Windows
	newDom = newDom.replace(/%7C\//g, ":/");
	ed.rebuildDocumentFromSource(newDom);
	setTimeout("filltextarea(false)", 1000);
}

function openEditHTMLbar() {
	document.getElementById("editHTMLvbox").removeAttribute("hidden");
	document.getElementById("editHTMLsplitter").removeAttribute("hidden");
	document.getElementById("editHTMLbrowser").setAttribute("src", "chrome://edithtml/content/editWindow.xul");
	setTimeout("filltextarea(true)", 500);
}

function closearea() {
	var mainWindow = getMainWindow();
	mainWindow.document.getElementById("editHTMLvbox").setAttribute("hidden", "true");
}
